// analyse.js
// date: /^(\d{4}|\d{2})\/(\d{2})\/(\d{2})/
// time: /(\d{2}):(\d{2}):(\d{2}).(\d{2})$/
//       /(\d{2}):(\d{2}):(\d{2})$/
//       /(\d{2}):(\d{2})$/

var Analyse = {
	analyse: function() {
		dialogAnalyse.clear();
		// -------------
		dialogAnalyse.addPage ("Thread", "Xbh", SKIN_PATH + "img/thread.png");
		dialogAnalyse.addFrame("Thread", "Summary", "Tv");
		dialogAnalyse.addLabel("Thread", "Summary", "", "^Cg:");
		dialogAnalyse.addLabel("Thread", "Summary", "", ThreadDocument.title,null,1);
		dialogAnalyse.addLabel("Thread", "Summary", "", "URL:");
		dialogAnalyse.addLink ("Thread", "Summary", "", EXACT_URL, EXACT_URL,null,1);
		dialogAnalyse.addLabel("Thread", "Summary", "", "X:");
		dialogAnalyse.addLabel("Thread", "Summary", "", ThreadDocument.countAll,null,1);
		dialogAnalyse.addLabel("Thread", "Summary", "", ":");
		var lastIndex = (ThreadDocument.countAll > 1000) ? 1000 : ThreadDocument.countAll;
		dialogAnalyse.addLabel("Thread", "Summary", "", this.getDate(1).toLocaleString() + " ` " + this.getDate(lastIndex).toLocaleString(),null,1);
		dialogAnalyse.addLabel("Thread", "Summary", "", "(" + this.toStringfromTimeDiff((this.getDate(lastIndex).getTime() - this.getDate(1).getTime())) + ")",null,1);
		dialogAnalyse.addLabel("Thread", "Summary", "", ":");
		dialogAnalyse.addLabel("Thread", "Summary", "", this.getPaceString(),null,1);
		// -------------
		dialogAnalyse.addPage ("User", "̐l", SKIN_PATH + "img/user.png");
		dialogAnalyse.addFrame("User", "Name", "O",96);
		var resItems = Nodes.getResItems();
		var nameArray = new Array();
		for (var i = 0; i < resItems.length; i++) {
			var name = Nodes.getName(Nodes.getIndexFromRes(resItems[i])).textContent;
			if (nameArray["_" + name]) {
				nameArray["_" + name].count++;
			} else {
				nameArray["_" + name] = {name: name, count: 1};
			}
		}
		for (var i in nameArray) {
			nameArray.push(nameArray[i]);
		}
		nameArray.sort(function(a,b){return b.count - a.count});
		for (var i = 0; i < nameArray.length; i++) {
			if (nameArray[i].count > 1) dialogAnalyse.addLabel("User", "Name", "", nameArray[i].name + "(" + nameArray[i].count + ")");
		}
		// ---
		dialogAnalyse.addFrame("User", "ID", "ID",96);
		var resItems = Nodes.getResItems();
		var idArray = new Array();
		for (var i = 0; i < resItems.length; i++) {
			var id = Nodes.getID(Nodes.getIndexFromRes(resItems[i])).textContent;
			if (idArray["_" + id]) {
				idArray["_" + id].count++;
			} else {
				idArray["_" + id] = {id: id, count: 1};
			}
		}
		for (var i in idArray) {
			idArray.push(idArray[i]);
		}
		idArray.sort(function(a,b){return b.count - a.count});
		dialogAnalyse.addLabel("User", "ID", "", "v " + idArray.length + " ID");
		for (var i = 0; i < idArray.length; i++) {
			if (idArray[i].count > 1) dialogAnalyse.addID("User", "ID", "", idArray[i].id, idArray[i].count);
		}
		// ---
		dialogAnalyse.addFrame("User", "Trackback", "lCX",96);
		var resItems = Nodes.getResItems();
		var trackbackArray = new Array();
		Trackback.traverse();
		for (var i = 0; i < resItems.length; i++) {
			var index = Nodes.getIndexFromRes(resItems[i]);
			trackbackArray.push({index: index, count: Trackback.getCount(index)});
		}
		trackbackArray.sort(function(a,b){return b.count - a.count});
		var hasbeenAdded = false;
		for (var i = 0; i < trackbackArray.length; i++) {
			if (trackbackArray[i].count > 1) {
				dialogAnalyse.addTrackback("User", "Trackback", "", trackbackArray[i].index, trackbackArray[i].count);
				hasbeenAdded = true;
			}
		}
		if (!hasbeenAdded) dialogAnalyse.addLabel("User", "Trackback", "", "Ȃ");
		// -------------
		dialogAnalyse.addPage ("Link", "N", SKIN_PATH + "img/external.png");
		dialogAnalyse.addFrame("Link", "2ch", "2ch", 128);
		dialogAnalyse.addFrame("Link", "External", "OTCg",128);
		dialogAnalyse.addPage ("Image", "摜", SKIN_PATH + "img/image.png");
		dialogAnalyse.addFrame("Image", "Image", "ꗗ",256);
		dialogAnalyse.addPage ("Video", "", SKIN_PATH + "img/video.png");
		dialogAnalyse.addFrame("Video", "Video", "ꗗ",256);
		var a = document.getElementsByTagName("a");
		var array = new Array();
		var imageCount = 0;
		var videoCount = 0;
		var extCount = 0;
		var chCount = 0;
		for (var i = 0; i < a.length; i++) {
			if (a[i].parentNode.className == "resBody") {
				if (a[i].className == "outLink") {
					if (array[a[i].href]) continue;
					array[a[i].href] = true;
					var src = a[i].href
					if (src.match(/\?url=/)) src = RegExp.rightContext;
					if (ImagePopup.isImage(src)) {
						imageCount++;
						dialogAnalyse.addLink ("Image", "Image", "", src, a[i].href, Nodes.getIndexFromBody(a[i].parentNode));
					} else if (VideoPopup.getVideoSource(src)) {
						videoCount++;
						dialogAnalyse.addLink ("Video", "Video", "", src, a[i].href, Nodes.getIndexFromBody(a[i].parentNode));
					} else {
						if (src.indexOf("2ch.net/") == -1) {
							extCount++;
							dialogAnalyse.addLink ("Link", "External", "", src, a[i].href, Nodes.getIndexFromBody(a[i].parentNode));
						} else {
							chCount++;
							dialogAnalyse.addLink ("Link", "2ch", "", src, a[i].href, Nodes.getIndexFromBody(a[i].parentNode));
						}
					}
				}
			}
		}
		if (!imageCount) dialogAnalyse.addLabel ("Image", "Image", "", "Ȃ");
		if (!videoCount) dialogAnalyse.addLabel ("Video", "Video", "", "Ȃ");
		if (!extCount)   dialogAnalyse.addLabel ("Link", "External", "", "Ȃ");
		if (!chCount)    dialogAnalyse.addLabel ("Link", "2ch", "", "Ȃ");
		// -------------
		dialogAnalyse.show();
	},
	getDate: function(index) {
		var str = Nodes.getDate(index).textContent;
		str.match(/^(\d{4}|\d{2})\/(\d{2})\/(\d{2})/);
		var fullYear  = parseInt(RegExp.$1);
		if (fullYear < 100) fullYear += (fullYear >= 90) ? 1900 : 2000;
		var date = new Date(RegExp.$2 + "/" + RegExp.$3 + "/" + fullYear);
		if (str.match(/(\d{2}):(\d{2}):(\d{2}).(\d{2})(\s|$)/)) {
			date.setHours(parseInt(RegExp.$1));
			date.setMinutes(parseInt(RegExp.$2));
			date.setSeconds(parseInt(RegExp.$3));
			date.setMilliseconds(parseInt(RegExp.$4));
		} else if (str.match(/(\d{2}):(\d{2}):(\d{2})(\s|$)/)) {
			date.setHours(parseInt(RegExp.$1));
			date.setMinutes(parseInt(RegExp.$2));
			date.setSeconds(parseInt(RegExp.$3));
		} else if (str.match(/(\d{2}):(\d{2})(\s|$)/)) {
			date.setHours(parseInt(RegExp.$1));
			date.setMinutes(parseInt(RegExp.$2));
		}
		return date;
	},
	toStringfromTimeDiff: function(arg){
		var strReturn = new String();
		var valDate = Math.floor(arg / 31536000000);
		if (valDate > 0) strReturn += valDate + "N";
		var valDate = Math.floor((arg % 31536000000) / 2628000000);
		if (valDate > 0) strReturn += valDate + "";
		var valDate = Math.floor(((arg % 31536000000) % 2628000000) / 86400000);
		if (valDate > 0) strReturn += valDate + " ";
		var valDate = Math.floor((((arg % 31536000000) % 2628000000) % 86400000) / 3600000) ;
		if (valDate > 0) strReturn += valDate + "";
		var valDate = Math.floor(((((arg % 31536000000) % 2628000000) % 86400000) % 3600000) / 60000);
		if (valDate > 0) strReturn += valDate + "";
		if (strReturn.length == 0) {
			var valDate = Math.floor((((((arg % 31536000000) % 2628000000) % 86400000) % 3600000) % 60000) / 1000 * 1000) / 1000;
		} else {
			var valDate = Math.floor((((((arg % 31536000000) % 2628000000) % 86400000) % 3600000) % 60000) / 1000);
		}
		if (valDate > 0) strReturn += valDate + "b";
		return strReturn;
	},
	getPaceString: function(){
		var lastIndex = (ThreadDocument.countAll > 1000) ? 1000 : ThreadDocument.countAll;
		return this.toStringfromTimeDiff((this.getDate(lastIndex).getTime() - this.getDate(1).getTime()) / lastIndex) + " / X";
	}
};


var dialogAnalyse = {
	content: document.createElement("div"),
	onOK: function(){
		this.hide();
	},
	onResize: function(){
		dialogAnalyse.content.style.left = (document.body.offsetWidth - dialogAnalyse.content.offsetWidth) / 2
		dialogAnalyse.content.style.top  = (window.innerHeight - dialogAnalyse.content.offsetHeight) / 2
		var bg = document.getElementById("dialogAnalyseBackground");
		if (bg) {
			bg.style.width = document.body.offsetWidth;
			bg.style.height = window.innerHeight;
		}
	},
	show: function(){
		var bg = document.createElement("div");
		bg.id = "dialogAnalyseBackground";
		bg.style.width = document.body.offsetWidth;
		bg.style.height = window.innerHeight;
		document.body.appendChild(bg);

		this.content.style.position   = "fixed";
		this.content.style.width      = 512;
		this.content.style.visibility = "hidden"
		this.content.style.display    = "block";
		this.selectPage(this.content.childNodes[1].id.replace("Page_", ""));
		this.content.style.left = (document.body.offsetWidth - this.content.offsetWidth) / 2
		this.content.style.top  = (window.innerHeight - this.content.offsetHeight) / 2
		this.content.style.visibility = "visible";
		window.addEventListener("resize", dialogAnalyse.onResize, false);
	},
	hide: function(){
		this.content.style.display = "none";
		var bg = document.getElementById("dialogAnalyseBackground");
		if (bg) document.body.removeChild(bg);
		window.removeEventListener("resize", dialogAnalyse.onResize, false);
	},
	clear: function(){
		if (document.getElementById("dialogAnalyse")) {
			document.body.removeChild(document.getElementById("dialogAnalyse"));
			this.content = document.createElement("div");
		}
	},
	selectPage: function(id){
		var divHeader = document.getElementById("dialogAnalyseHeader");
		for (var i = 0; i < divHeader.childNodes.length - 1; i++) {
			var icon = divHeader.childNodes[i];
			if (icon.id == "Icon_" + id) {
				icon.className = "icon" + " " + "selected";
			} else {
				icon.className = "icon";
			}
		}	
		for (var i = 1; i < this.content.childNodes.length - 1; i++) {
			var page = this.content.childNodes[i];
			if (page.id == "Page_" + id) {
				page.style.display = "block";
			} else {
				page.style.display = "none";
			}
		}
		if ((this.content.offsetTop + this.content.offsetHeight) > window.innerHeight) this.onResize();
	},
	addPage: function(id, caption, icon){
		if (!this.content.id) this.content.id = "dialogAnalyse";
		if (!document.getElementById("dialogAnalyse")) document.body.appendChild(this.content);
		var divHeader = document.getElementById("dialogAnalyseHeader");
		if (!divHeader) {
			divHeader = document.createElement("div");
			divHeader.id = "dialogAnalyseHeader";
			divHeader.className = "header";
			var divHeaderEnd = document.createElement("div");
			divHeaderEnd.id = "dialogAnalyseHeaderEnd";
			divHeaderEnd.className = "null";
			divHeader.appendChild(divHeaderEnd);
			this.content.appendChild(divHeader);
			
			var p      = document.createElement("p");
			var ok     = document.createElement("input");
			ok.setAttribute("type",  "submit");
			ok.setAttribute("value", "OK");
			ok.setAttribute("onclick", "dialogAnalyse.onOK()");
			p.appendChild(ok);
			this.content.appendChild(p);
		}
		
		var divIcon = document.createElement("div");
		divIcon.id = "Icon_" + id;
		divIcon.className = "icon";
		divIcon.textContent = caption;
		divIcon.style.backgroundImage = "url(" + icon + ")";
		divIcon.setAttribute("onclick", "dialogAnalyse.selectPage('" + id + "')");
		divHeader.insertBefore(divIcon, document.getElementById("dialogAnalyseHeaderEnd"));
		
		var divPage = document.createElement("div");
		divPage.id = "Page_" + id;
		divPage.style.display = "none";
		this.content.insertBefore(divPage, this.content.lastChild);
	},
	addFrame: function(page, id, caption, maxheight){
		var fieldset = document.createElement("fieldset");
		fieldset.id = "Frame_" + page + "_" + id;
		var legend  = document.createElement("legend");
		legend.textContent = caption;
		fieldset.appendChild(legend);
		var ul = document.createElement("ul");
		if (maxheight) ul.style.maxHeight = maxheight;
		fieldset.appendChild(ul);
		var divPage = document.getElementById("Page_" + page);
		if (divPage) divPage.appendChild(fieldset);
	},
	addLabel: function(page, frame, id, caption, index, level){
		var parentObject = document.getElementById("Frame_" + page + "_" + frame).lastChild;
		if (level > 0) {
			for (var i = 1; i <= level; i++) {
				parentObject.appendChild(document.createElement("ul"));
				parentObject = parentObject.lastChild;
			}
		}
		var li = document.createElement("li");
		var label = document.createElement("label");
		label.className = "dialogAnalyseLabel";
		var span = document.createElement("span");
		span.textContent = caption;
		label.appendChild(span);
		if (index) {
			var a = document.createElement("a");
			a.setAttribute("href", "javascript:void(0)");
			a.setAttribute("className", "resPointer");
			a.textContent = "(>>" + index + ")";
			label.appendChild(a);
		}
		li.appendChild(label);
		parentObject.appendChild(li);
	},
	addLink: function(page, frame, id, caption, uri, index, level){
		var parentObject = document.getElementById("Frame_" + page + "_" + frame).lastChild;
		if (level > 0) {
			for (var i = 1; i <= level; i++) {
				parentObject.appendChild(document.createElement("ul"));
				parentObject = parentObject.lastChild;
			}
		}
		var li = document.createElement("li");
		var label = document.createElement("label");
		label.className = "dialogAnalyseLabel";
		var a = document.createElement("a");
		a.setAttribute("href", uri);
		a.setAttribute("target", "_blank");
		a.className = "outLink";
		a.textContent = caption;
		label.appendChild(a);
		if (index) {
			label.appendChild(document.createTextNode(" ("));
			var a = document.createElement("a");
			a.setAttribute("href", "javascript:void(0)");
			a.className = "resPointer";
			a.textContent = ">>" + index;
			label.appendChild(a);
			label.appendChild(document.createTextNode(")"));
		}
		li.appendChild(label);
		parentObject.appendChild(li);
	},
	addID: function(page, frame, id, caption, count, level){
		var parentObject = document.getElementById("Frame_" + page + "_" + frame).lastChild;
		if (level > 0) {
			for (var i = 1; i <= level; i++) {
				parentObject.appendChild(document.createElement("ul"));
				parentObject = parentObject.lastChild;
			}
		}
		var li = document.createElement("li");
		var label = document.createElement("label");
		label.className = "dialogAnalyseLabel";
		var a = document.createElement("a");
		a.setAttribute("href", "");
		a.setAttribute("target", "_blank");
		a.className = "mesID_none";
		a.textContent = caption;
		label.appendChild(a);
		label.appendChild(document.createTextNode("(" + count + ")"));
		li.appendChild(label);
		parentObject.appendChild(li);
	},
	addTrackback: function(page, frame, id, index, count, level){
		var parentObject = document.getElementById("Frame_" + page + "_" + frame).lastChild;
		if (level > 0) {
			for (var i = 1; i <= level; i++) {
				parentObject.appendChild(document.createElement("ul"));
				parentObject = parentObject.lastChild;
			}
		}
		var li = document.createElement("li");
		var label = document.createElement("label");
		label.className = "dialogAnalyseLabel";
		var a = document.createElement("a");
		a.setAttribute("href", "");
		a.setAttribute("target", "_blank");
		a.className = "resPointer";
		a.textContent = ">>" + index;
		label.appendChild(a);
		label.appendChild(document.createTextNode("(" + count + ")"));
		li.appendChild(label);
		parentObject.appendChild(li);
	}
};