// general.js
// (2007/02/03)

var Nodes = {
	header:     document.getElementById("header"),
	command:    document.getElementById("command"),
	menu:       document.getElementById("menu"),
	findBox:    document.getElementById("findbox"),
	findBoxText:document.getElementById("findboxText"),
	resCount:   document.getElementById("resCount"),
	statusText: document.getElementById("statusText"),
	threadName: document.getElementById("threadName"),
	initialise: function() {
		this.header      = document.getElementById("header");
		this.command     = document.getElementById("command");
		this.menu        = document.getElementById("menu");
		this.findBox     = document.getElementById("findbox");
		this.findBoxText = document.getElementById("findboxText");
		this.resCount    = document.getElementById("resCount");
		this.statusText  = document.getElementById("statusText");
		this.threadName  = document.getElementById("threadName");
	},
	getResItems: function() {
		return document.getElementsByName("resItems");
	},
	getIDItems: function() {
		return document.getElementsByName("idItems");
	},
	getRes: function(index) {
		return document.getElementById("res" + index);
	},
	getBody: function(index) {
		return document.getElementById("body" + index);
	},
	getName: function(index) {
		return document.getElementById("res" + index).childNodes[1].childNodes[3].childNodes[1];
	},
	getMail: function(index) {
		return document.getElementById("res" + index).childNodes[1].childNodes[3].childNodes[3];
	},
	getDate: function(index) {
		return document.getElementById("res" + index).childNodes[1].childNodes[3].childNodes[5];
	},
	getID: function(index) {
		return document.getElementById("res" + index).childNodes[1].childNodes[3].childNodes[7];
	},
	getBeID: function(index) {
		return document.getElementById("res" + index).childNodes[1].childNodes[3].childNodes[9];
	},
	getIndexFromRes: function(node) {
		if (node) return parseInt(node.id.slice(3));
	},
	getIndexFromBody: function(node) {
		if (node) return parseInt(node.id.slice(4));
	}
};

var ThreadDocument = {
	title: "",
	status: "",
	countAll: null,
	countRead: null,
	countUnread: null,
	date: new Date(),
	initialise: function(statusText, getResCount, newResCount, allResCount) {
		this.title          = document.title;
		this.status         = statusText;
		this.countRead      = parseInt(getResCount);
		this.countUnread    = parseInt(newResCount);
		this.countAll       = parseInt(allResCount);
		Nodes.initialise();
		ResPopup.initialise();
		IDPopup.initialise();
		TrackbackPopup.initialise();
		ImagePopup.initialise();
		AADetect.initialise();
		UrlPopup.initialise();
		VideoPopup.initialise();
		IDExtract.initialise();
		KeyInput.initialise();
		AutoReload.initialise();
		this.setStatus(true);
		this.scrollToNewRes();
		this.colourIDs();
		this.modifyAnchors();
		if (SkinPref.getBool("enableContract", true)) window.addEventListener("resize", ThreadDocument.contractCaption, false);
		window.addEventListener("contextmenu", ThreadDocument.onContextMenu, false);
	},
	onContextMenu: function(e) {
		if (e.target.tagName != "SPAN") if (e.target.tagName != "A") return;
		if (window.getSelection().toString().length > 0) return;
		var range = window.getSelection();
		range.removeAllRanges();
		window.getSelection().selectAllChildren(e.target);
		e.returnValue = true;
	},
	setClipboard: function(text) {
		// őC^[tF[X:
		// http://la.ma.la/misc/js/setClipboard2.html
		swf_data = SKIN_PATH + "setClipboard.swf";
		var tmp = document.createElement("div");
		tmp.innerHTML = [
			 '<embed src="', swf_data, '"'
			,' FlashVars="code=',encodeURI(text),'"'
			,' width="0" height="0"'
			,'></embed>'
		].join("");
		with(tmp.style){
			position ="absolute";
			left = "-10px";
			top  = "-10px";
			visibility = "hidden";
		};
		document.body.appendChild(tmp);
		setTimeout(function(){document.body.removeChild(tmp)},1000)
		return;
	},
	copyThreadInfo: function() {
		ThreadDocument.setClipboard(ThreadDocument.title + "\n" + EXACT_URL + "\n");
	},
	scrollTo: function(y) {
		if (!(SkinPref.getBool("enableSmoothScroll", true))) {
			window.scrollTo(0, y);
			return;
		}
		var y1 = window.pageYOffset;
		var y2 = parseInt(y)
		if (y2 < 0) y2 = 0;
		if ((y2 + window.innerHeight) > document.body.offsetHeight) y2 = document.body.offsetHeight - window.innerHeight;
		var delta = y2 - y1;
		//var steps = 32;
		switch (SkinPref.getInt("valueSmoothScrollFrames", 1)) {
		case 0:
			var steps = 16;  break;
		case 1:
			var steps = 24;  break;
		case 2:
			var steps = 32; break;
		default:
			var steps = 24;
		}
		steps=24;
		var a = (delta / 2) * 2 / Math.pow(steps / 2, 2);
		var ha = a / 2;
		for (var x = 0; x < steps / 2; ++x) {
			window.scrollTo(0, y1 + (ha *Math.pow(x, 2)) );
		}
		for (var x = steps / 2 - 1; x >= 0; --x) {
			window.scrollTo(0, y2 - (ha * Math.pow(x, 2)));
		}					
		window.scrollTo(0, y2);
	},	
	writeTo: function(number) {
		window.location.href="bbs2ch:post:" + EXACT_URL + number; 
	},
	markAsRead: function() {
		var dt = document.getElementsByTagName("dt");
		for (var i = 0; i < dt.length; i++) {
			if (dt[i].className == "resNewHeader") dt[i].className = "resHeader";
		}
	},
	scrollToNewRes: function(){
		if(document.location.href.indexOf("#") != -1) return;
		var hrNew = document.getElementById("NewMark");
		if (hrNew) window.scrollTo(0, hrNew.offsetTop - (Nodes.header.offsetTop + Nodes.header.offsetHeight));
		//if (hrNew) smoothScrollTo(hrNew.offsetTop - (divHeader.offsetTop + divHeader.offsetHeight));
	},
	setStatus: function(updateStatus) {
		Nodes.resCount.textContent = "(" + this.countAll + ")";
		if (updateStatus) if (this.countUnread > 0) 
			this.status = "(߁)uV " + this.countUnread + "v";
		Nodes.statusText.textContent = this.status;
		this.contractCaption();
	},
	getCaptionWidth: function(str) {
		var span  = document.createElement("span");
		span.visibility = "hidden";
		span.appendChild(document.createTextNode(str));
		Nodes.header.appendChild(span);
		var width = span.offsetWidth;
		Nodes.header.removeChild(span);
		return width;
	},
	contractCaption: function() {
		var statusWidth = (Nodes.statusText.offsetLeft + Nodes.statusText.offsetWidth) - (Nodes.threadName.offsetWidth);
		var dotWidth    = ThreadDocument.getCaptionWidth("...");
		if (ThreadDocument.getCaptionWidth(ThreadDocument.title) + statusWidth > Nodes.command.offsetLeft) {
			for (var i = 1; i < ThreadDocument.title.length; i++) {
				if ((ThreadDocument.getCaptionWidth(ThreadDocument.title.substring(0,i)) + dotWidth + statusWidth) > Nodes.command.offsetLeft) {
					Nodes.threadName.textContent = ThreadDocument.title.substring(0,i-1) + "...";
					break;
				}
			}
		} else {
			Nodes.threadName.textContent = ThreadDocument.title;
		}
	},
    colourIDs: function() {
		var	idItems = Nodes.getIDItems();
		var idIndex = new Array();		
		for (var i = 0; i < idItems.length; i++) {
			var txtID = idItems[i].textContent;
			if (txtID.length < 4) continue;
			if (txtID.match(/^ID:\?\?\?/)) continue;
			if (!idIndex[txtID]) idIndex[txtID] = 0;
			idIndex[txtID]++;
		}
		for (var i = 0; i < idItems.length; i++) {
			if (idItems[i].textContent.length < 4) {
				idItems[i].style.visibility = "hidden";
			} else { 
				if (idIndex[idItems[i].textContent] == 2) { 
					idItems[i].className = "resID1";
					idItems[i].setAttribute("onclick", "IDExtract.extract(event)");
				} else if (idIndex[idItems[i].textContent] > 2) {
					idItems[i].className = "resID2";
					idItems[i].setAttribute("onclick", "IDExtract.extract(event)");
				}
			}
		}

		var	span = document.getElementsByTagName("span");
		for (var i = 0; i < span.length; i++) {
			if (span[i].className.match(/^mesID_/)) {
				if (span[i].textContent.length > 4) {
					if ((idIndex[span[i].textContent] == 1) || (idIndex[span[i].textContent] == 2)) { 
						span[i].className = "mesID_" + span[i].textContent.slice(3) + " resID1";
						span[i].setAttribute("onclick", "IDExtract.extract(event)");
					} else if (idIndex[span[i].textContent] > 2) {
						span[i].className = "mesID_" + span[i].textContent.slice(3) + " resID2";
						span[i].setAttribute("onclick", "IDExtract.extract(event)");
					}
				}
			}
		}
	},
	modifyAnchors: function() {
		var a = document.getElementsByTagName("a");
		var enableNewWindow = SkinPref.getBool("enableNewWindow", true);
		var enableNoReferer = SkinPref.getBool("enableNoReferer", true);
		for (var i = 0; i < a.length; i++) {
			if (a[i].className == "resPointer"){
				a[i].href = "javascript:void(0)";
				a[i].setAttribute("onclick", "ThreadDocument.jumpTo(event)");
			}
			if (a[i].className == "outLink"){
				if (a[i].target != "_blank") {
					if (enableNoReferer) a[i].href = SKIN_PATH + "ime.nu.html?url=" + a[i].href;
					if (enableNewWindow) a[i].target = "_blank";
				}
			}
		}
	},
	flagDigest: false,
	digest: function(showHeader) {
		this.flagDigest = !this.flagDigest;
		var dd = document.getElementsByTagName("dd");
		var expSingleAnchor = new RegExp(/(>?>|)(\d{1,4})/);
		Trackback.traverse();
		if (!Trackback.items) return;
		if (this.flagDigest) {
			for (var i = 0; i < dd.length; i++) if (!Trackback.items[dd[i].id.slice(4)]) if (!dd[i].textContent.match(expSingleAnchor)) if (showHeader) {  dd[i].style.display = "none"; } else { dd[i].parentNode.style.display = "none"; }
		} else {
			for (var i = 0; i < dd.length; i++) if (showHeader) { dd[i].style.display = "block"; } else { dd[i].parentNode.style.display = "block"; }
		}
	},
	asyncInsert: function(start, end, before, scrollToTop) {
		var xmlHTTP = new XMLHttpRequest();
	    xmlHTTP.onreadystatechange = xmlEventHandler;
	    function xmlEventHandler() {
	        if (xmlHTTP.readyState == 4) {
	            if (xmlHTTP.status == 200) {
					var divTemp  = document.createElement("div");
	                divTemp.innerHTML = xmlHTTP.responseText;
	            	var divContent  = document.getElementById("content");
					var resItems = Nodes.getResItems();
					var resStart = Nodes.getRes(1);
        			resStart = (resStart) ? resItems[1] : resItems[0];
					if (resStart.parentNode.id.length == 0) resStart = resStart.parentNode;					
	                var dl = divTemp.getElementsByTagName("dl");
					var divParent = dl[0].parentNode;
					divParent.id = "";
					
					if (before) {
						divContent.insertBefore(divParent, resStart);
						window.scrollTo(0,0);
					} else {
						divContent.appendChild(divParent);
					}
					
					ThreadDocument.colourIDs();
					ThreadDocument.modifyAnchors();
					
					if (scrollToTop) {
						window.scrollTo(0,0);
					} else {
						var resStart = Nodes.getRes(start);
						if (resStart) window.scrollTo(0, resStart.offsetTop - (Nodes.header.offsetTop + Nodes.header.offsetHeight));
					}
					ThreadDocument.flagDigest = false;
				}
	        }
	    }
	    xmlHTTP.open("GET", SERVER_URL + EXACT_URL + start + "-" + end + "n", true);
	    xmlHTTP.send(null);
	},
	showAll: function(){
		var resItems = Nodes.getResItems();
		for(var i = 0; i < resItems.length; i++) resItems[i].style.display = "block";
		ThreadDocument.flagDigest = false;
		var resStart = Nodes.getRes(1);
        resStart = (resStart) ? resItems[1] : resItems[0];
		var startIndex = Nodes.getIndexFromRes(resStart);
		var endIndex   = Nodes.getIndexFromRes(resItems[resItems.length-1]);
        if (!Nodes.getRes(1)) this.asyncInsert(1, 1, true, true);
		if (startIndex > 2) this.asyncInsert(2, startIndex - 1, true, true);
		if (endIndex < this.countAll) this.asyncInsert(endIndex + 1, this.countAll, false, true);
	},
	reload: function(noScroll){
		if (this.countAll >= 1000) if (EXACT_URL.indexOf("2ch.net") != -1) return;
		var now = new Date();
		if ((now.getTime() - this.date.getTime()) < 5000) {
			this.status = "( ְ)uӁ[v";
			this.setStatus();
			return;
		}
		this.date = now;
		this.markAsRead();
		var xmlHTTP = new XMLHttpRequest();
	    xmlHTTP.onreadystatechange = xmlEventHandler;
	    function xmlEventHandler() {
	        if (xmlHTTP.readyState == 4) {
	            if (xmlHTTP.status == 200) {
	            	var divContent  = document.getElementById("content");
					var divTemp  = document.createElement("div");
	                divTemp.innerHTML = xmlHTTP.responseText;
	                var dl = divTemp.getElementsByTagName("dl");
	                // XVȂ΍Ō̃XAĂ
	                if (dl.length == 1) {
	                	ThreadDocument.status = "( ְ)uVȂv";
	                	ThreadDocument.countUnread = 0;
	                	ThreadDocument.countRead   = ThreadDocument.countAll;
						ThreadDocument.setStatus();
	                	return;
	                }
	                // ]ɂĂĂ܂̂ŁA
	                dl[0].parentNode.removeChild(dl[0]);
                	ThreadDocument.countRead   = ThreadDocument.countAll;
                	ThreadDocument.countUnread = dl.length;
                	ThreadDocument.countAll    = ThreadDocument.countRead + ThreadDocument.countUnread;
					ThreadDocument.setStatus(true);
					var divParent = dl[0].parentNode;
					divParent.id = "";
					divContent.appendChild(divParent);
					
					ThreadDocument.colourIDs();
					ThreadDocument.modifyAnchors();
					if (!noScroll) {
						var resStart = Nodes.getRes(ThreadDocument.countRead + 1);
						if (resStart) window.scrollTo(0, resStart.offsetTop - (Nodes.header.offsetTop + Nodes.header.offsetHeight));
						//if (resStart) smoothScrollTo(resStart.offsetTop - (divHeader.offsetTop + divHeader.offsetHeight));
					}
					ThreadDocument.flagDigest = false;
				}
	        }
	    }
	    xmlHTTP.open("GET", SERVER_URL + EXACT_URL + "l1n", true);
	    xmlHTTP.send(null);
	},
	toNarrow: function(str) {
		return parseInt(str.replace(/([O-X])/g, function(n){ return String.fromCharCode(n.charCodeAt(0) - 0xFEE0); }));
	},
	jumpTo: function(e){
		var node = e.target;
		switch (node.className) {
		case "resPointer":
			if (node.textContent.match(/(>?>|)(\d{1,4})-(\d{1,4})/)) {
				var start = ThreadDocument.toNarrow(RegExp.$2);
				var end   = ThreadDocument.toNarrow(RegExp.$3);
			} else if (node.textContent.match(/(>?>|)(\d{1,4})/)) {
				var start = ThreadDocument.toNarrow(RegExp.$2);
				var end   = start;
			}
			break;
		case "resName":
			if (node.textContent.match(/^(\d{1,4})-(\d{1,4})$/)) {
				var start = ThreadDocument.toNarrow(RegExp.$1);
				var end   = ThreadDocument.toNarrow(RegExp.$2);
			} else if (node.textContent.match(/^(\d{1,4})$/)) {
				var start = ThreadDocument.toNarrow(RegExp.$1);
				var end   = start;
			}
			break;
		default:
			return;
		}
		var resTarget = Nodes.getRes(start);
		if (resTarget) {
			var newStart = 0;
			for(var i = start + 1; i <= end; i++){
				if (!ThreadDocument.getRes(i)) {
					newStart = i;
					break;
				}
			}
			if (newStart==0) {
				window.scrollTo(0, resTarget.offsetTop - (Nodes.header.offsetTop + Nodes.header.offsetHeight));
				//smoothScrollTo(resTarget.offsetTop - (divHeader.offsetTop + divHeader.offsetHeight));
				return;
			}
			start = newStart;
		}
		var resItems = Nodes.getResItems();
		var resStart = Nodes.getRes(1);
        resStart = (resStart) ? resItems[1] : resItems[0];
		var startIndex = Nodes.getIndexFromRes(resStart);
		var endIndex   = Nodes.getIndexFromRes(resItems[resItems.length-1]);
		if (start < startIndex) ThreadDocument.asyncInsert(start, startIndex - 1, true, false);
		if (endIndex < end)     ThreadDocument.asyncInsert(endIndex, end, true, false);
	}
};

var AADetect = {
	checked: new Array(),
	initialise: function() {
		this.checked = new Array();
		window.addEventListener("scroll", AADetect.traverse, false);
	},
	isAA: function(node) {
    	var t = node.textContent;
    	var expChar = new RegExp("");
    	expChar.compile("[^-ꞁXY-@-[a-zA-Z0-9-`-yO-XABI!H?()ijuvwx \n]", "g");
    	var expLine = new RegExp("");
    	expLine.compile("<br>", "g");
    	var expSpace = new RegExp("");
    	expSpace.compile("[ @.:i|]", "g");
		var lineCount = node.innerHTML.match(expLine);
		if (lineCount) if (lineCount.length >= 3) {
			var spaceCount = t.match(expSpace);
			if (spaceCount) if (((spaceCount.length-lineCount.length) / t.length) >= 0.3) {
				var charCount = t.match(expChar);
				if (charCount) if ((charCount.length / t.length) >= 0.4) {
					return true;
				}
			}
		}
		return false;
	},
	traverse: function() {
		if (!SkinPref.getBool("enableAADetect", true)) return;
		var dd = document.getElementsByTagName("dd");
		var top = window.pageYOffset;
		var bottom = top + window.innerHeight;
		for (var i = Math.floor(dd.length / 2); i > 0; i--) {
			if (dd[i].offsetTop > bottom) continue;
			if (dd[i].offsetTop + dd[i].offsetHeight < top) break;
			if (!AADetect.checked[dd[i].id]) {
				if (dd[i].className == "resBody") {
					AADetect.checked[dd[i].id] = true;
					if (AADetect.isAA(dd[i])) dd[i].className = "resBodyAA";
				}
			}
		}
		for (var i = Math.floor(dd.length / 2) + 1; i < dd.length; i++) {
			if (dd[i].offsetTop > bottom) break;
			if (dd[i].offsetTop + dd[i].offsetHeight < top) continue;
			if (!AADetect.checked[dd[i].id]) {
				if (dd[i].className == "resBody") {
					AADetect.checked[dd[i].id] = true;
					if (AADetect.isAA(dd[i])) dd[i].className = "resBodyAA";
				}
			}
		}
	}
};

var IDExtract = {
	id: "",
	initialise: function() {
		IDExtract.proc();
	},
	proc: function() {
		if (!location.href.match(/\?id=/)) return;
		id = RegExp.rightContext;
		if (id.length < 4) return;
		if (id.match(/^ID:\?\?\?/)) return;
		var resItems = Nodes.getResItems();
		var	idItems  = Nodes.getIDItems();
		var idCount  = 0;
		Trackback.traverse();
		for (var i = 0; i < resItems.length; i++) {
			if (idItems[i].textContent.indexOf(id,0) != -1){
				Trackback.appendTo(resItems[i], Nodes.getIndexFromRes(resItems[i]));
				resItems[i].style.display = "block";
				idCount++;
			} else {
				resItems[i].style.display = "none";
			}
		}
		ThreadDocument.status = id + " ̃X (" + idCount + ")";
		ThreadDocument.setStatus();
		IDExtract.id = id;
	},
	extract: function(e) {
		if (e.target.textContent == IDExtract.id) return;
		if (e.target.className == "resID") return;
		window.open(SERVER_URL + EXACT_URL + "?id=" + e.target.textContent);
		e.returnValue = true;
	}
};

var KeyInput = {
	initialise: function() {
		window.addEventListener("keydown", KeyInput.onKeyDown, false);
	},
	onKeyDown: function(e) {
		KeyInput.scrollProc(e);
		KeyInput.reloadProc(e);
		KeyInput.showAllProc(e);
		KeyInput.writeProc(e);
		if (e.keyCode == 70) if (e.altKey || e.ctrlKey) FindBox.show();
	},
	writeProc: function(e){
		if (e.ctrlKey) if (e.keyCode == 13) {
			location.href = "bbs2ch:post:" + EXACT_URL;
			e.preventDefault();
		}
	},
	showAllProc: function(e){
		if (e.ctrlKey) if (e.keyCode == 229 || e.keyCode == 32) {
			ThreadDocument.showAll();
			e.preventDefault();
		}
	},
	reloadProc: function(e){
		if (!SkinPref.getBool("enableHookReload", true)) return;
		if (e.keyCode == 116) {
			ThreadDocument.reload();
			e.preventDefault();
		}
	},
	scrollProc: function(e){
		var node = e.target.tagName;
		if (node.tagName == 'TEXTAREA' || node.tagName == 'INPUT' || e.shiftKey || e.ctrlKey || e.altKey) return;
		var top    = window.pageYOffset + (Nodes.header.offsetTop + Nodes.header.offsetHeight);
		var bottom = window.pageYOffset + window.innerHeight;
		var resItems = Nodes.getResItems();
		switch (e.which) {
		case 37:
			for (var i = resItems.length - 1; i >= 0 ; --i) {
				if (resItems[i].offsetTop < top) {
					var resTop = resItems[i];
					if (resTop) ThreadDocument.scrollTo(resTop.offsetTop - (Nodes.header.offsetTop + Nodes.header.offsetHeight));
					break;
				}
			}
			e.preventDefault();
			break;
		case 39:
			for (var i = 0; i < resItems.length; ++i) {
				if (resItems[i].offsetTop > bottom) {
					var resTop = resItems[i-1];
					if (resTop) ThreadDocument.scrollTo((resTop.offsetTop + resTop.offsetHeight) - window.innerHeight);
					break;
				}
			}
			if (!resTop) ThreadDocument.scrollTo(document.body.offsetHeight);
			e.preventDefault();
		}
	}
};

var Menu = {
	initialised: false,
	onMouseDown: function(e) {
		if ((e.target.tagName != "LI") || (e.target.parentNode.parentNode.parentNode.parentNode.parentNode.id != "menu"))
			Menu.hide();
	},
	onClick: function(e) {
		if (e.target.tagName == "LI")
			if (e.target.parentNode.parentNode.parentNode.parentNode.parentNode.id == "menu")
				Menu.hide();
	},
	check: function(id, value) {
		document.getElementById(id).className = (value) ? "checked" : "";
	},
	show: function() {
		if (Nodes.menu.style.display != "block") {
			Menu.check("digest", ThreadDocument.flagDigest)
			Menu.check("autoreload", AutoReload.enabled)
			Nodes.menu.style.display = "block";
		} else {
			Menu.hide();
		}
		if (!Menu.initialised) {
			Menu.initialised = true;
			window.addEventListener("click", Menu.onClick, false);
			window.addEventListener("mousedown", Menu.onMouseDown, false);
		}
	},
	hide: function() {
		Nodes.menu.style.display = "none";
	}
}

var FindBox = {
	initialised: false,
	onKeyDown:   function(e) {
		if (e.target.id == "findboxText") if (e.keyCode == 13) FindBox.find();
	},
	onClick:     function(e) {
		if (e.target.id == "findboxClear") FindBox.clear();
	},
	onMouseDown: function(e) {
		switch (e.target.id) {
		case "findboxText":
		case "findboxClear":
		case "findbox":
		case "find":
			break;
		default:
			if (!Nodes.findBoxText.value.length) FindBox.hide();
		}
	},
	show: function() {
		if (Nodes.findBox.style.display != "block") {
			Nodes.findBox.style.display = "block";
			Nodes.findBoxText.focus();
		} else {
			FindBox.hide();
		}
		if (!FindBox.initialised) {
			FindBox.initialised = true;
			window.addEventListener("click",     FindBox.onClick, false);
			window.addEventListener("mousedown", FindBox.onMouseDown, false);
			window.addEventListener("keydown",   FindBox.onKeyDown, false);
		}
	},
	hide: function() {
		Nodes.findBox.style.display = "none";
	},
	clear: function() {
		Nodes.findBoxText.value = "";
		Nodes.findBoxText.className = "";
		var items = Nodes.getResItems();
		for (var i = 0; i < items.length; i++) {
			items[i].style.display = "block";
		}
	},
	escapeExpression: function(str) {
		return str.replace(/([.*+?^${}()|[\]\/\\])/g, '\\$1');
	},
	find: function() {
		var items = Nodes.getResItems();
		var isFound = false;
		for (var i = 0; i < items.length; i++) {
			//items[i].style.display = (items[i].textContent.match(FindBox.escapeExpression(Nodes.findBoxText.value), "i")) ? "block" : "none";
			if (items[i].textContent.match(FindBox.escapeExpression(Nodes.findBoxText.value), "i")) {
				isFound = true;
				items[i].style.display = "block";
			} else {
				items[i].style.display = "none";
			}
		}
		Nodes.findBoxText.className = (isFound) ? "found" : "notfound";
	}
};

var AutoReload = {
	enabled: false,
	timerID: 0,
	initialise: function() {
		if (SkinPref.getBool("enableAutoReloadOnLiveThread", false)) 
			if (EXACT_URL.indexOf("/read.cgi/live") != -1) this.toggle();
	},
	timerProc: function() {
		var items = Nodes.getResItems();
		var lastItem = items[items.length - 1];
		ThreadDocument.reload(!(window.scrollY + window.innerHeight > lastItem.offsetTop + lastItem.offsetHeight));
	},
	toggle: function() {
		this.enabled = !this.enabled;
		if (this.timerID) { window.clearInterval(this.timerID); this.timerID = 0; }
		if (this.enabled) {
			switch (SkinPref.getInt("valueAutoReloadInterval",1)) {
			case 0:
				this.timerID = window.setInterval(AutoReload.timerProc, 15000);
				break;
			case 1:
				this.timerID = window.setInterval(AutoReload.timerProc, 30000);
				break;
			case 2:
				this.timerID = window.setInterval(AutoReload.timerProc, 60000);
			}
		}
	}
}