// option.js
// (2007/02/02)
// IvV_CAO𓮓Iɍ쐬/Ǘ
// pref.jsƘAg悤ɂłĂ̂ŏɃ}[W

var SkinPref = {

	_skinName: "smorgasbord",
	_skinVersion: "2007/02/10",
	_skinURI: "http://smorgasbord.drwatson.nobody.jp/",
	_skinMail: "\u0064\u0072\u0077\u0061\u0074\u0073\u006f\u006e\u002e\u0065\u0078\u0065\u002b\u0073\u006d\u006f\u0072\u0067\u0061\u0073\u0062\u006f\u0072\u0064\u0040\u0067\u006d\u0061\u0069\u006c\u002e\u0063\u006f\u006d",
	
	_storage: globalStorage["localhost.localdomain"],
	
	_resolvePrefName: function(aPrefName){
		return this._skinName + "_" + aPrefName;
	},
	
	getStr: function(aPrefName, aDefaultValue){
		var item = this._storage.getItem(this._resolvePrefName(aPrefName));
		if(item == null) return aDefaultValue || "";
		return item.value;
	},
	setStr: function(aPrefName, aValue){
		var value = String(aValue);
		this._storage.setItem(this._resolvePrefName(aPrefName), value);
		return value;
	},

	getInt: function(aPrefName, aDefaultValue){
		var item = this._storage.getItem(this._resolvePrefName(aPrefName));
		if(item == null) return aDefaultValue || 0;
		return parseInt(item.value);
	},
	setInt: function(aPrefName, aValue){
		var value = parseInt(aValue);
		this._storage.setItem(this._resolvePrefName(aPrefName), value);
		return value;
	},

	getBool: function(aPrefName, aDefaultValue){
		var item = this._storage.getItem(this._resolvePrefName(aPrefName));
		if(item == null) return aDefaultValue || false;
		return (item.value == "true");
	},
	setBool: function(aPrefName, aValue){
		var value = (aValue) ? "true" : "false";
		this._storage.setItem(this._resolvePrefName(aPrefName), value);
		return value;
	}

};

var dialogOptions = {
	content: document.createElement("div"),
	onOK: function(){
		var items = document.getElementsByTagName("label");
		for (var i = 0; i < items.length; i++) {
			if (items[i].className == "dialogOptionsLabel") {
				if (items[i].firstChild.tagName == "INPUT") {
					switch (items[i].firstChild.getAttribute("type")) {
					case "checkbox":
						SkinPref.setBool(items[i].firstChild.id, items[i].firstChild.checked);
						break;
					case "radio":
						SkinPref.setBool(items[i].firstChild.id, items[i].firstChild.checked);
					}
				} else if (items[i].lastChild.tagName == "INPUT") {
					if (items[i].lastChild.getAttribute("type") == "text") {
						SkinPref.setStr(items[i].lastChild.id, items[i].lastChild.value);
					}
				} else if (items[i].lastChild.tagName == "SELECT") {
					SkinPref.setInt(items[i].lastChild.id, items[i].lastChild.selectedIndex);
				}
			}
		}
		this.hide();
	},
	onCancel: function(){
		this.hide();
	},
	onResize: function(){
		dialogOptions.content.style.left = (document.body.offsetWidth - dialogOptions.content.offsetWidth) / 2
		dialogOptions.content.style.top  = (window.innerHeight - dialogOptions.content.offsetHeight) / 2
		var bg = document.getElementById("dialogOptionsBackground");
		if (bg) {
			bg.style.width = document.body.offsetWidth;
			bg.style.height = window.innerHeight;
		}
	},
	show: function(){
		var bg = document.createElement("div");
		bg.id = "dialogOptionsBackground";
		bg.style.width = document.body.offsetWidth;
		bg.style.height = window.innerHeight;
		document.body.appendChild(bg);

		this.content.style.position   = "fixed";
		this.content.style.width      = 512;
		this.content.style.visibility = "hidden"
		this.content.style.display    = "block";
		this.selectPage(this.content.childNodes[1].id.replace("Page_", ""));
		this.content.style.left = (document.body.offsetWidth - this.content.offsetWidth) / 2
		this.content.style.top  = (window.innerHeight - this.content.offsetHeight) / 2
		this.content.style.visibility = "visible";
		window.addEventListener("resize", dialogOptions.onResize, false);
	},
	hide: function(){
		this.content.style.display = "none";
		var bg = document.getElementById("dialogOptionsBackground");
		if (bg) document.body.removeChild(bg);
		window.removeEventListener("resize", dialogOptions.onResize, false);
	},
	selectPage: function(id){
		var divHeader = document.getElementById("dialogOptionsHeader");
		for (var i = 0; i < divHeader.childNodes.length - 1; i++) {
			var icon = divHeader.childNodes[i];
			if (icon.id == "Icon_" + id) {
				icon.className = "icon" + " " + "selected";
			} else {
				icon.className = "icon";
			}
		}	
		for (var i = 1; i < this.content.childNodes.length - 1; i++) {
			var page = this.content.childNodes[i];
			if (page.id == "Page_" + id) {
				page.style.display = "block";
			} else {
				page.style.display = "none";
			}
		}
		if ((this.content.offsetTop + this.content.offsetHeight) > window.innerHeight) this.onResize();
	},
	addPage: function(id, caption, icon){
		if (!this.content.id) this.content.id = "dialogOptions";
		if (!document.getElementById("dialogOptions")) document.body.appendChild(this.content);
		var divHeader = document.getElementById("dialogOptionsHeader");
		if (!divHeader) {
			divHeader = document.createElement("div");
			divHeader.id = "dialogOptionsHeader";
			divHeader.className = "header";
			var divHeaderEnd = document.createElement("div");
			divHeaderEnd.id = "dialogOptionsHeaderEnd";
			divHeaderEnd.className = "null";
			divHeader.appendChild(divHeaderEnd);
			this.content.appendChild(divHeader);
			
			var p      = document.createElement("p");
			var ok     = document.createElement("input");
			ok.setAttribute("type",  "submit");
			ok.setAttribute("value", "OK");
			ok.setAttribute("onclick", "dialogOptions.onOK()");
			var cancel = document.createElement("input");
			cancel.setAttribute("type",  "button");
			cancel.setAttribute("value", "LZ");
			cancel.setAttribute("onclick", "dialogOptions.onCancel()");
			p.appendChild(ok);
			p.appendChild(cancel);
			this.content.appendChild(p);
		}
		
		var divIcon = document.createElement("div");
		divIcon.id = "Icon_" + id;
		divIcon.className = "icon";
		divIcon.textContent = caption;
		divIcon.style.backgroundImage = "url(" + icon + ")";
		divIcon.setAttribute("onclick", "dialogOptions.selectPage('" + id + "')");
		divHeader.insertBefore(divIcon, document.getElementById("dialogOptionsHeaderEnd"));
		
		var divPage = document.createElement("div");
		divPage.id = "Page_" + id;
		divPage.style.display = "none";
		this.content.insertBefore(divPage, this.content.lastChild);
	},
	addFrame: function(page, id, caption){
		var fieldset = document.createElement("fieldset");
		fieldset.id = "Frame_" + page + "_" + id;
		var legend  = document.createElement("legend");
		legend.textContent = caption;
		fieldset.appendChild(legend);
		fieldset.appendChild(document.createElement("ul"));
		var divPage = document.getElementById("Page_" + page);
		if (divPage) divPage.appendChild(fieldset);
	},
	addLabel: function(page, frame, id, caption, level){
		var parentObject = document.getElementById("Frame_" + page + "_" + frame).lastChild;
		if (level > 0) {
			for (var i = 1; i <= level; i++) {
				parentObject.appendChild(document.createElement("ul"));
				parentObject = parentObject.lastChild;
			}
		}
		var li = document.createElement("li");
		var label = document.createElement("label");
		label.className = "dialogOptionsLabel";
		var span = document.createElement("span");
		span.textContent = caption;
		label.appendChild(span);
		li.appendChild(label);
		parentObject.appendChild(li);
	},
	addLink: function(page, frame, id, caption, uri, level){
		var parentObject = document.getElementById("Frame_" + page + "_" + frame).lastChild;
		if (level > 0) {
			for (var i = 1; i <= level; i++) {
				parentObject.appendChild(document.createElement("ul"));
				parentObject = parentObject.lastChild;
			}
		}
		var li = document.createElement("li");
		var label = document.createElement("label");
		label.className = "dialogOptionsLabel";
		var a = document.createElement("a");
		a.setAttribute("href", uri);
		a.setAttribute("target", "_blank");
		a.textContent = caption;
		label.appendChild(a);
		li.appendChild(label);
		parentObject.appendChild(li);
	},
	addCheckBox: function(page, frame, id, caption, defaultValue, level){
		var parentObject = document.getElementById("Frame_" + page + "_" + frame).lastChild;
		if (level > 0) {
			for (var i = 1; i <= level; i++) {
				parentObject.appendChild(document.createElement("ul"));
				parentObject = parentObject.lastChild;
			}
		}
		var li = document.createElement("li");
		var label = document.createElement("label");
		label.className = "dialogOptionsLabel";
		var input = document.createElement("input");
		input.setAttribute("type", "checkbox");
		input.id = id;
		input.checked = SkinPref.getBool(id, defaultValue);
		label.appendChild(input);
		var span = document.createElement("span");
		span.textContent = caption;
		label.appendChild(span);
		li.appendChild(label);
		parentObject.appendChild(li);
	},
	addRadio: function(page, frame, id, caption, defaultValue, level){
		var parentObject = document.getElementById("Frame_" + page + "_" + frame).lastChild;
		if (level > 0) {
			for (var i = 1; i <= level; i++) {
				parentObject.appendChild(document.createElement("ul"));
				parentObject = parentObject.lastChild;
			}
		}
		var li = document.createElement("li");
		var label = document.createElement("label");
		label.className = "dialogOptionsLabel";
		var input = document.createElement("input");
		input.setAttribute("type", "radio");
		input.setAttribute("name", frame);
		input.id = id;
		input.checked = SkinPref.getBool(id, defaultValue);
		label.appendChild(input);
		var span = document.createElement("span");
		span.textContent = caption;
		label.appendChild(span);
		li.appendChild(label);
		parentObject.appendChild(li);
	},
	addEditBox: function(page, frame, id, caption, defaultValue, size, level){
		var parentObject = document.getElementById("Frame_" + page + "_" + frame).lastChild;
		if (level > 0) {
			for (var i = 1; i <= level; i++) {
				parentObject.appendChild(document.createElement("ul"));
				parentObject = parentObject.lastChild;
			}
		}
		var li = document.createElement("li");
		var label = document.createElement("label");
		label.className = "dialogOptionsLabel";
		var span = document.createElement("span");
		span.textContent = caption;
		label.appendChild(span);
		var input = document.createElement("input");
		input.setAttribute("type", "text");
		input.value = SkinPref.getStr(id, defaultValue);
		if (size) {
			input.style.width = size + "em";
		}
		input.id = id;
		
		label.appendChild(input);
		li.appendChild(label);
		parentObject.appendChild(li);
	},
	addNumberBox: function(page, frame, id, caption, defaultValue, size, level){
		var parentObject = document.getElementById("Frame_" + page + "_" + frame).lastChild;
		if (level > 0) {
			for (var i = 1; i <= level; i++) {
				parentObject.appendChild(document.createElement("ul"));
				parentObject = parentObject.lastChild;
			}
		}
		var li = document.createElement("li");
		var label = document.createElement("label");
		label.className = "dialogOptionsLabel";
		var span = document.createElement("span");
		span.textContent = caption;
		label.appendChild(span);
		var input = document.createElement("input");
		input.setAttribute("type", "text");
		if (size) {
			input.style.width = size + "em";
		}		
		input.id = id;
		input.value = SkinPref.getStr(id, defaultValue);
		input.setAttribute("onkeydown", "var i = event.keyCode; if ((i >= 96 && i <= 105) || (i >= 48 && i <= 57) || (i == 190) | (i == 8) || (i == 35) || (i == 36) ||(i == 37) || (i == 39) || (i == 46)) { return true; } return false;");
		input.setAttribute("onkeyup",  "if (event.target.value.match(/[^0-9\.]+/)) event.target.value='';");
		input.setAttribute("onfocus",  "if (event.target.value.match(/[^0-9\.]+/)) event.target.value='';");
		input.setAttribute("onblur",  "if (event.target.value.match(/[^0-9\.]+/)) event.target.value='';");
		label.appendChild(input);
		li.appendChild(label);
		parentObject.appendChild(li);
	},
	addComboBox: function(page, frame, id, caption, value, defaultValue, level){
		var parentObject = document.getElementById("Frame_" + page + "_" + frame).lastChild;
		if (level > 0) {
			for (var i = 1; i <= level; i++) {
				parentObject.appendChild(document.createElement("ul"));
				parentObject = parentObject.lastChild;
			}
		}
		var li = document.createElement("li");
		var label = document.createElement("label");
		label.className = "dialogOptionsLabel";
		var span = document.createElement("span");
		span.textContent = caption;
		label.appendChild(span);
		var select = document.createElement("select");
		select.id = id;
		for (var i = 0; i < value.length; i++) {
			var option = document.createElement("option");
			option.textContent = value[i];
			option.setAttribute("value", value[i]);
			select.appendChild(option);
		}
		select.selectedIndex = SkinPref.getInt(id, defaultValue);
		label.appendChild(select);
		li.appendChild(label);
		parentObject.appendChild(li);
	}
};

function initOptionDialog(){
	dialogOptions.addPage     ("General", "",  SKIN_PATH + "img/general.png");
	dialogOptions.addFrame    ("General", "Link",  "N");
	dialogOptions.addCheckBox ("General", "Link",  "enableNewWindow", "NVEBhEŊJ", true);
	dialogOptions.addCheckBox ("General", "Link",  "enableNoReferer", "t@𑗐MȂ", true);
	dialogOptions.addFrame    ("General", "Popup", "|bvAbv");
	dialogOptions.addLabel    ("General", "Popup", "labelPopup", "̃|bvAbvLɂ:");
	dialogOptions.addCheckBox ("General", "Popup", "enableResPopup", "AJ[", true, 1);
	dialogOptions.addCheckBox ("General", "Popup", "enableIDPopup", "ID", true, 1);
	dialogOptions.addCheckBox ("General", "Popup", "enableImagePopup", "摜", true, 1);
	dialogOptions.addCheckBox ("General", "Popup", "enableUrlPopup", "NTlC", true, 1);
	dialogOptions.addCheckBox ("General", "Popup", "enableVideoPopup", "", true, 1);
	dialogOptions.addCheckBox ("General", "Popup", "videoPopupAutoStart", "Đ", true, 2);
	dialogOptions.addCheckBox ("General", "Popup", "enableTrackBackPopup", "tQ", true, 1);
	
	dialogOptions.addPage     ("Special", "ڍ",  SKIN_PATH + "img/special.png");
	dialogOptions.addFrame    ("Special", "Visualisation",  "o");
	dialogOptions.addCheckBox ("Special", "Visualisation",  "enableContract", "Xbh^Cg\ɍ킹ďȗ\", true);
	dialogOptions.addCheckBox ("Special", "Visualisation",  "enablePopupFade", "|bvAbṽtF[hAEgLɂ", true);
	dialogOptions.addComboBox ("Special", "Visualisation",  "valuePopupFadeStep", "tF[h̃Xebv: ", new Array(0.1,0.2,0.25,0.33,0.5), 1, 1);

	dialogOptions.addFrame    ("Special", "Browse", "uEY");
	dialogOptions.addCheckBox ("Special", "Browse", "enableAADetect", "I AA 𔻕ʂtHgύX", true);
	dialogOptions.addCheckBox ("Special", "Browse", "enableHookReload", "F5 L[tbNēIɍXVs", true);
	dialogOptions.addCheckBox ("Special", "Browse", "enableSmoothScroll", "X[YXN[Lɂ", true);
	dialogOptions.addComboBox ("Special", "Browse", "valueSmoothScrollFrames", "t[: ", new Array("ŏ","","ő"), 1, 1);
	
	dialogOptions.addFrame    ("Special", "AutoPilot",  "I[gpCbg");
	dialogOptions.addCheckBox ("Special", "AutoPilot", "enableAutoReloadOnLiveThread", "ł͎XVftHgɂ", false);
	dialogOptions.addComboBox ("Special", "AutoPilot", "valueAutoReloadInterval", "XV̊Ԋu: ", new Array("15 b","30 b","60 b"), 1);
	
	dialogOptions.addPage     ("About", "XL",  "chrome://bbs2chreader/content/icon.png");
	dialogOptions.addFrame    ("About", "Info",  "̃XLɂ");
	if (SkinPref._skinName)
		dialogOptions.addLabel("About", "Info", "labelSkinName", SkinPref._skinName);
	if (SkinPref._skinVersion)
		dialogOptions.addLabel("About", "Info", "labelSkinVersion", "o[W: " + SkinPref._skinVersion);
	if (SkinPref._skinURI) {
		// dialogOptions.addLabel("About", "Info", "labelSkinBlank", "@");
		dialogOptions.addLink ("About", "Info", "labelSkinURI", SkinPref._skinURI, SkinPref._skinURI);
	}
	if (SkinPref._skinMail)
		dialogOptions.addLink ("About", "Info", "labelSkinMail", SkinPref._skinMail, "mailto:" + SkinPref._skinMail);	
	
	dialogOptions.addFrame    ("About", "Keymap",  "L[{[hV[gJbg");
	dialogOptions.addLabel    ("About", "Keymap", "", "F5: ŐV̏ɍXV");
	dialogOptions.addLabel    ("About", "Keymap", "", ": ÕXֈړ");
	dialogOptions.addLabel    ("About", "Keymap", "", ": ̃Xֈړ");
	dialogOptions.addLabel    ("About", "Keymap", "", "Ctrl + Enter: ");
	dialogOptions.addLabel    ("About", "Keymap", "", "Ctrl + Space: ׂĕ\");
	dialogOptions.addLabel    ("About", "Keymap", "", "Ctrl + Alt + F: /o");
}
window.addEventListener("load", initOptionDialog, false);
