// popup.js
// (2007/02/02)


// PopupItem IuWFNg
// |bvAbṽm[h
//
//   \bh
//     vCx[g
//       initialize: RXgN^
//   vpeB
//     pubN
//       container: |bvAbv̍ŏw̗vf
//       content:   |bvAbv̍ŉw̗vf
//       source:    |bvAbv̗vf
//
function PopupItem() {
    this.initialise.apply(this, arguments);
}
PopupItem.prototype = {
	container: null,
	content:   null,
	source:    null,
    initialise: function(source) {
		var divPopupContainer          = document.createElement("div");
		divPopupContainer.className    = "popupContainer";
		var divShadowTopRight          = document.createElement("div");
		divShadowTopRight.className    = "shadowTopRight";
		var divShadowBottomLeft        = document.createElement("div");
		divShadowBottomLeft.className  = "shadowBottomLeft";
		var divShadowBottomRight       = document.createElement("div");
		divShadowBottomRight.className = "shadowBottomRight";
		var divPopupBorder             = document.createElement("div");
		divPopupBorder.className       = "popupBorder";
		var divShadowRight             = document.createElement("div");
		divShadowRight.className       = "shadowRight";
		var divShadowBottom            = document.createElement("div");
		divShadowBottom.className      = "shadowBottom";
		var divPopupBody               = document.createElement("div");
		divPopupBody.className         = "popupBody";
		
		divShadowBottom.appendChild(divPopupBody);
		divShadowRight.appendChild(divShadowBottom);
		divPopupBorder.appendChild(divShadowRight);
		divShadowBottomRight.appendChild(divPopupBorder);
		divShadowBottomLeft.appendChild(divShadowBottomRight);
		divShadowTopRight.appendChild(divShadowBottomLeft);
		divPopupContainer.appendChild(divShadowTopRight);
		
		this.source    = source;
		this.container = divPopupContainer;
		this.content   = divPopupBody;
    }
};


// Popup IuWFNg
// |bvAbvS
//
//   \bh
//     pubN
//       add:           |bvAbvǉ
//     vCx[g
//       getRect:       vf̐΍WԂ
//       isPtInElement: Wvfɂ邩ǂԂ
//       remove:        |bvAbv폜
//   vpeB
//     vCx[g
//       items:         PopupItem i[z
//       initialised:   tO
//
var Popup = {
	items:       new Array(),
	initialised: false,
	getRect: function(src) {
		var parent = src;
		var x = 0;
		var y = 0;
		while (parent) {
			x += parent.offsetLeft;
			y += parent.offsetTop;
			parent = parent.offsetParent;
		}
		if (src.parentNode.tagName == "LABEL") y += window.scrollY - 
			src.parentNode.parentNode.parentNode.scrollTop; // set y to the right position on the analyse dialog
		return {left: x, top: y, width: src.offsetWidth, height: src.offsetHeight,
		        right: x + src.offsetWidth, bottom: y + src.offsetHeight};
	},
	isPtInElement: function(x, y, element) {
		var rc = Popup.getRect(element);
		return (x >= rc.left) && (x <= rc.right) && (y >= rc.top) && (y <= rc.bottom);
	},
	sourceExists: function(source) {
		for (var i = 0; i < Popup.items.length; i++) {
			if (Popup.items[i].source == source) return true;
		}
		return false;
	},
	reposition: function(item) {
		var rectSource = Popup.getRect(item.source);
		item.container.style.left = rectSource.left;
		item.container.style.top  = rectSource.bottom;
		
		if (rectSource.bottom + item.container.offsetHeight > window.scrollY + window.innerHeight) {
			var oppositeY = (rectSource.top - item.container.offsetHeight);
			if (oppositeY >= window.scrollY + Nodes.header.offsetHeight) item.container.style.top = oppositeY;
		}
		//if ( window.scrollMaxX > 0 )
		//	item.container.style.left = rectSource.left - window.scrollMaxX + window.scrollX;
		if (rectSource.left + item.container.offsetWidth > window.scrollX + document.body.clientWidth)
			item.container.style.left = rectSource.left - window.scrollMaxX + window.scrollX;
	},
	add: function(content, source) {
		if (Popup.sourceExists(source)) return;
		var item = new PopupItem(source);
		Popup.items.push(item);
		item.content.appendChild(content);
		document.body.appendChild(item.container);
		Popup.reposition(item);
		
		if (!Popup.initialised) {
			window.addEventListener("mouseout", Popup.remove, false);
			Popup.initialised = true;
		}
		
		// ThreadDocument.colourIDs();
		ThreadDocument.modifyAnchors();

		return item;
	},
	remove: function(e) {
		var x = e.pageX;
		var y = e.pageY;
		for (var i = Popup.items.length - 1; i >= 0; i--) {
			if (Popup.isPtInElement(x, y, Popup.items[i].source))    return;
			if (Popup.isPtInElement(x, y, Popup.items[i].container)) return;
			if (SkinPref.getBool("enablePopupFade", true)) {
				Popup.removeChildWithFade(Popup.items[i].container);
			} else {
				document.body.removeChild(Popup.items[i].container);
			}
			Popup.items.pop();
		}
	},
	findPopup: function(content) {
		for (var i = 0; i < Popup.items.length; i++) {
			if (Popup.items[i].content.firstChild == content) return Popup.items[i];
		}
		return null;
	},
	fadeOutProc: function(id) {
		var node = document.getElementById(id);
		if (node) {
			var fadeStep = SkinPref.getInt("valuePopupFadeStep", 1);
			switch(fadeStep){
			case 0:
				fadeStep = 0.1;  break;
			case 1:
				fadeStep = 0.2;  break;
			case 2:
				fadeStep = 0.25; break;
			case 3:
				fadeStep = 0.33; break;
			case 4:
				fadeStep = 0.5;  break;
			default:
				fadeStep = 0.2;
			}
			node.style.opacity = parseFloat(node.style.opacity) - fadeStep;
			if (parseFloat(node.style.opacity) <= 0.0) {
				document.body.removeChild(node);
			} else {
				window.setTimeout(Popup.fadeOutProc, 1, id);
			}
		}
	},
	removeChildWithFade: function(node){
		var id = "#" + new Date().getTime() + Math.random();
		node.id = id
		node.style.opacity = 1.0;
		window.setTimeout(Popup.fadeOutProc, 1, id);
	}
};


// Trackback IuWFNg
// tQ
//
//   \bh
//     pubN
//       traverse: X𑖍ċtQƏ\z
//       appendTo: w肳ꂽvfɋtQƏǉ
//     vCx[g
//       toNarrow: Sp𐔒l^ɕϊ
//       add:      tQƏzɒǉ
//   vpeB
//     vCx[g
//       items:    tQƏi[z
//       count:    X
//
var Trackback = {
	items: new Array(),
	count: null,
	toNarrow: function(str) {
		return parseInt(str.replace(/([O-X])/g, function(n){ return String.fromCharCode(n.charCodeAt(0) - 0xFEE0); }));
	},
	add: function(destIndex, srcIndex) {
		if (this.items[destIndex]) {
			for (var i = 0; i < this.items[destIndex].length; i++)	if (this.items[destIndex][i] == srcIndex) return;
		} else {
			this.items[destIndex] = new Array();
		}
		this.items[destIndex].push(srcIndex);
	},
	getCount: function(index) {
		if (!this.items[index]) return 0;
		return this.items[index].length;
	},
	appendTo: function(content, index) {
		if (!this.items[index]) return;
		var span = document.createElement("span");
		span.className="trackBack";
		span.appendChild(document.createTextNode("(Q:"));
		for (var i = 0; i < this.items[index].length; i++){
			var a = document.createElement("a");
			a.className = "resPointer";
			a.setAttribute("href", "#res" + this.items[index][i]);
			a.appendChild(document.createTextNode(">>" + this.items[index][i]));
			span.appendChild(a);
		}
		span.appendChild(document.createTextNode(")"));
		content.appendChild(span);
	},
	traverse: function() {
		const TRACKBACK_LIMIT = 20;
		var a = document.getElementsByTagName("a");
		var r = Nodes.getResItems();
		var expSingleAnchor = new RegExp(/(>?>|)(\d{1,4})/);
		var expMultiAnchor  = new RegExp(/(>?>|)(\d{1,4})-(\d{1,4})/);
		if (r.length == this.count) return;
		this.count = r.length;
		this.items = new Array();
		for(var i = 0; i < a.length; i++) {
			if (!a[i].parentNode.id) continue;
			if (a[i].className != "resPointer") continue;
			if (a[i].textContent.match(expMultiAnchor)) {
				var start = this.toNarrow(RegExp.$2);
				var end   = this.toNarrow(RegExp.$3);
			} else if (a[i].textContent.match(expSingleAnchor)) {
				var start = this.toNarrow(RegExp.$2);
				var end   = start;
			} else {
				continue;
			}
			if ((end - start) < TRACKBACK_LIMIT) {
				for(var destIndex = start; destIndex <= end; destIndex++) {
					var srcIndex = a[i].parentNode.id.slice(4); // body
					this.add(destIndex, srcIndex);
				}
			}
		}
	}
}

// ResPopup IuWFNg
// Xԃ|bvAbviƖO|bvAbvj
//
var ResPopup = {
	initialise: function() {
		window.addEventListener("mouseover", ResPopup.onMouseOver, false);
	},
	toNarrow: function(str) {
		return parseInt(str.replace(/([O-X])/g, function(n){ return String.fromCharCode(n.charCodeAt(0) - 0xFEE0); }));
	},
	getCloneNode: function(src){
		var dest = src.cloneNode(true);
		if (dest.id) dest.id = "";
		dest.removeAttribute("name");
		dest.style.display = "block";
		var e = dest.getElementsByTagName("*");
		for(var i=0; i<e.length; i++){
			if(e[i].id) e[i].id = "";
			e[i].removeAttribute("name");
		}
		return dest;
	},
	onMouseOver: function(e) {
		var node = e.target;
		switch (node.className) {
			case "resPointer":
				if (node.textContent.match(/(>?>|)(\d{1,4})-(\d{1,4})/)) {
					ResPopup.show(node, ResPopup.toNarrow(RegExp.$2), ResPopup.toNarrow(RegExp.$3));
				} else if (node.textContent.match(/(>?>|)(\d{1,4})/)) {
					ResPopup.show(node, ResPopup.toNarrow(RegExp.$2), ResPopup.toNarrow(RegExp.$2));
				}
				break;
			case "resName":
				if (node.textContent.match(/^(\d{1,4})-(\d{1,4})$/)) {
					node.style.cursor = "pointer";
					ResPopup.show(node, ResPopup.toNarrow(RegExp.$1), ResPopup.toNarrow(RegExp.$2));
					node.setAttribute("onclick", "ThreadDocument.jumpTo(event)")
				} else if (node.textContent.match(/^(\d{1,4})$/)) {
					node.style.cursor = "pointer";
					ResPopup.show(node, ResPopup.toNarrow(RegExp.$1), ResPopup.toNarrow(RegExp.$1));
					node.setAttribute("onclick", "ThreadDocument.jumpTo(event)")
				}
		}
	},
	show: function(source, start, end) {
		const POPUP_LIMIT = 20;
		if (!SkinPref.getBool("enableResPopup", true)) return;
		if (end < start) return;
		if (start < 1)  start = 1;
		if (end > 1000) end = 1000;
		if ((end - start) > POPUP_LIMIT) end = start + POPUP_LIMIT;
		Trackback.traverse();
		var content = document.createDocumentFragment();
		for(var i = start; i <= end; i++){
			resNode = Nodes.getRes(i);
			if(!resNode) {
				ResPopup.showExceeded(source, start, end);
				return;
			}
			var dlPopup = ResPopup.getCloneNode(resNode);
			dlPopup.className = "resPopup";
			Trackback.appendTo(dlPopup, start);
			content.appendChild(dlPopup);
		}
		Popup.add(content, source);
	},
	showExceeded: function(source, start, end) {
	    var xmlHTTP = new XMLHttpRequest();
	    xmlHTTP.onreadystatechange = xmlEventHandler;
	    function xmlEventHandler() {
	        if (xmlHTTP.readyState == 4) {
	            if (xmlHTTP.status == 200) {
					var content = document.createDocumentFragment();
					var divTemp  = document.createElement("div");
	                divTemp.innerHTML = xmlHTTP.responseText;
	                var dl = divTemp.getElementsByTagName("dl");
					for(var i = 0; i < dl.length; i++){
						var dlPopup = ResPopup.getCloneNode(dl[i]);
						dlPopup.className = "resPopup";
						Trackback.appendTo(dlPopup, start);
						content.appendChild(dlPopup);
					}
					Popup.add(content, source);
	            }
	        }
	    }
    	xmlHTTP.open("GET", SERVER_URL + EXACT_URL + start + "-" + end + "n", true);
	    xmlHTTP.send(null);
	}
};

// IDPopup IuWFNg
// ID|bvAbv
//
var IDPopup = {
	initialise: function() {
		window.addEventListener("mouseover", IDPopup.onMouseOver, false);
	},
	getCloneNode: function(src){
		var dest = src.cloneNode(true);
		if (dest.id) dest.id = "";
		dest.removeAttribute("name");
		dest.style.display = "block";
		var e = dest.getElementsByTagName("*");
		for(var i=0; i<e.length; i++){
			if(e[i].id) e[i].id = "";
			e[i].removeAttribute("name");
		}
		return dest;
	},
	onMouseOver: function(e) {
		var node = e.target;
		if (node.className.match(/mesID_/)) {
			IDPopup.show(node, node.textContent, true);
		} else if (node.className.match(/^resID/)) {
			IDPopup.show(node, node.textContent, false);
		}
	},
	show: function(source, id, popupOnBody) {
		if (!SkinPref.getBool("enableIDPopup", true)) return;
		const IDENTIFIER = "IDPopup:";
		if (id.length < 4) return;
		if (id.match(/^ID:\?\?\?/)) return;
		if (document.getElementById(IDENTIFIER + id)) return;
		Trackback.traverse();
		var content  = document.createDocumentFragment();
		var	resItems = Nodes.getResItems();
		var	idItems  = Nodes.getIDItems();
		var idCount  = 0;
		for (var i = 0; i < resItems.length; i++) {
			if (idItems[i].textContent != id) continue;
			if (resItems[i].id.length == 0)   continue;
			var dlPopup = IDPopup.getCloneNode(resItems[i]);
			dlPopup.className = "resPopup";
			Trackback.appendTo(dlPopup, resItems[i].id.slice(3)); // res
			content.appendChild(dlPopup)
			idCount++;
		}
		if (popupOnBody) {
			if (idCount < 1) return;
		} else {
			if (idCount < 2) return;
		}
		var span = document.createElement('span');
		span.id = IDENTIFIER + id;
		span.className = "idPopupInfo";
		span.appendChild(document.createTextNode(id + " ̃X (" + idCount + ")"));
		content.insertBefore(span, content.firstChild);
		Popup.add(content, source);
	}
};

// TrackbackPopup IuWFNg
// tQƃ|bvAbv
var TrackbackPopup = {
	initialise: function() {
		window.addEventListener("mouseover", TrackbackPopup.onMouseOver, false);
	},
	getCloneNode: function(src){
		var dest = src.cloneNode(true);
		if (dest.id) dest.id = "";
		dest.removeAttribute("name");
		var e = dest.getElementsByTagName("*");
		for(var i=0; i<e.length; i++){
			if(e[i].id) e[i].id = "";
			e[i].removeAttribute("name");
		}
		return dest;
	},
	onMouseOver: function(e) {
		var node = e.target;
		if (node.tagName != "A") return;
		if (node.parentNode.className != "resNumber") return;
		if (node.textContent.match(/^(\d{1,4})$/)) {
			TrackbackPopup.show(node, RegExp.$1);
		}
	},
	show: function(source, number) {
		if (!SkinPref.getBool("enableTrackBackPopup", true)) return;
		Trackback.traverse();
		var content  = document.createDocumentFragment();
		Trackback.appendTo(content, number);
		if (!content.firstChild) return;
		content.firstChild.className = "";
		var nodePopup = Popup.add(content, source);
		if (nodePopup) nodePopup.container.className = "popupTrackBack";
	}
};

// ImagePopup IuWFNg
// 摜|bvAbv
var ImagePopup = {
	initialise: function() {
		window.addEventListener("mouseover", ImagePopup.onMouseOver, false);
	},
	isImage: function(src) {
		return src.match(/\.(jpg|jpeg|png|gif|mng|tiff|tif|bmp|pict)$/i);
	},
	onMouseOver: function(e) {
		var node = e.target;
		if (node.className != "outLink") return;
		var src = node.href;
		if (src.match(/\?url=/)) src = RegExp.rightContext;
		if (ImagePopup.isImage(src)) ImagePopup.show(node, src);
	},
	onError: function(e) {
		var popup = Popup.findPopup(e.currentTarget.parentNode);
		if (popup) {
			popup.source.setAttribute("title", "G[");
		}
		e.currentTarget.parentNode.removeChild(e.currentTarget);
	},
	resize: function(nodePopup) {
		if (!nodePopup) return;
		if (!nodePopup.content.firstChild.firstChild) return;
		if ((nodePopup.content.firstChild.firstChild.offsetWidth != 0) && (nodePopup.content.firstChild.firstChild.offsetHeight != 0)) {
			if ((nodePopup.content.firstChild.firstChild.offsetWidth != 28) && (nodePopup.content.firstChild.firstChild.offsetHeight != 28)) {
				nodePopup.container.className = "popupImage";
				nodePopup.content.firstChild.firstChild.className = "imgPopup";
				nodePopup.content.style.maxWidth  = nodePopup.content.firstChild.firstChild.offsetWidth  - 7;
				nodePopup.content.style.maxHeight = nodePopup.content.firstChild.firstChild.offsetHeight - 7;
				Popup.reposition(nodePopup);
				nodePopup.container.style.visibility = "visible";
				return;
			}
		}
		window.setTimeout(ImagePopup.resize, 10, nodePopup);
	},
	show: function(source, href, videohref) {
		if (!SkinPref.getBool("enableImagePopup", true)) return;
		source.removeAttribute("title");
		var a   = document.createElement("a");
		a.href  = href;
		if (videohref) a.href = videohref;
		var img = document.createElement("img");
		img.src = href;
		img.setAttribute("onerror", "ImagePopup.onError(event)");
		a.appendChild(img);
		var nodePopup = Popup.add(a, source);
		if (nodePopup) {
			nodePopup.container.style.visibility = "hidden";
			window.setTimeout(ImagePopup.resize, 10, nodePopup);
		}
	}
};

// UrlPopup IuWFNg
// N|bvAbv
// http://spa.snap.com/preview/?url=hogehoge&key=spakey&src=www.snap.com&cp=spa_preview!www.snap.com&sb=0&v=2
// http://img.simpleapi.net/small/hogehoge
//
var UrlPopup = {
	initialise: function() {
		window.addEventListener("mouseover", UrlPopup.onMouseOver, false);
	},
	isValid: function(src) {
		if (src.match(/(http|https):\/\/.+\/.*\.([a-zA-Z0-9]+)$/)) {
			var ext = RegExp.$2;
			return ext.match(/^(htm|html|shtm|shtml|stm|xml|xhtml|php|php3|php4|cgi|jsp|cfm|asp|aspx|pl|plx|py|rb|)$/);
		} else {
			return true;
		}
	},
	onMouseOver: function(e) {
		var node = e.target;
		if (node.className != "outLink") return;
		var src = node.href;
		if (src.match(/\?url=/)) src = RegExp.rightContext;
		if (src.match(/2ch.net/)) return;
		if (src.match(/read\.cgi/)) return;
		if (ImagePopup.isImage(src)) return;
		if (VideoPopup.getVideoSource(src)) return;
		if (UrlPopup.isValid(src)) UrlPopup.show(node, src);
	},
	onError: function(e) {
		var popup = Popup.findPopup(e.currentTarget.parentNode);
		if (popup) {
			popup.source.setAttribute("title", "G[");
		}
		e.currentTarget.parentNode.removeChild(e.currentTarget);
	},
	resize: function(nodePopup) {
		if (!nodePopup) return;
		if (!nodePopup.content.firstChild.firstChild) return;
		if ((nodePopup.content.firstChild.firstChild.offsetWidth != 0) && (nodePopup.content.firstChild.firstChild.offsetHeight != 0)) {
			if ((nodePopup.content.firstChild.firstChild.offsetWidth != 28) && (nodePopup.content.firstChild.firstChild.offsetHeight != 28)) {
				nodePopup.container.className = "popupImage";
				nodePopup.content.firstChild.firstChild.className = "urlPopup";
				nodePopup.content.style.maxWidth  = nodePopup.content.firstChild.firstChild.offsetWidth  - 7;
				nodePopup.content.style.maxHeight = nodePopup.content.firstChild.firstChild.offsetHeight - 7;
				Popup.reposition(nodePopup);
				nodePopup.container.style.visibility = "visible";
				return;
			}
		}
		window.setTimeout(UrlPopup.resize, 10, nodePopup);
	},
	show: function(source, href) {
		if (!SkinPref.getBool("enableUrlPopup", true)) return;
		source.removeAttribute("title");
		var a   = document.createElement("a");
		a.href  = href;
		var img = document.createElement("img");
		img.src = "http://spa.snap.com/preview/?url=" + encodeURIComponent(href) + "&key=spakey&src=www.snap.com&cp=spa_preview!www.snap.com&sb=0&v=2";
		img.setAttribute("onerror", "UrlPopup.onError(event)");
		a.appendChild(img);
		var nodePopup = Popup.add(a, source);
		if (nodePopup) {
			nodePopup.container.style.visibility = "hidden";
			window.setTimeout(UrlPopup.resize, 10, nodePopup);
		}
	}
};

// VideoPopup IuWFNg
// |bvAbv
//

var VideoPopup = {
	initialise: function() {
		window.addEventListener("mouseover", VideoPopup.onMouseOver, false);
	},
	getVideoSource: function(src) {
		if (src.match(/youtube.com\/.*\?v=([^\&]+)/)) {
			var option = SkinPref.getBool("videoPopupAutoStart", true) ? "&autoplay=1" : "";
      		return "http://www.youtube.com/v/" + RegExp.$1 + option;
	    } else if (src.match(/stage6.divx.com\/.*\?content_id=(\d+)/)) {
	    	return "http://images.stage6.com/videos/" + RegExp.$1 + ".jpg";
	    } else if (src.match(/stage6.divx.com\/.*\/show_video\/(\d+)/)) {
	    	return "http://images.stage6.com/videos/" + RegExp.$1 + ".jpg";
	    } else if (src.match(/stage6.divx.com\/members\/(\d+)\/videos\/(\d+)/)) {
	    	return "http://video.stage6.com/" + RegExp.$1 + "/" + RegExp.$2 + ".divx";
	    } else if (src.match(/video.google.*\?docid=([\d\-]+)/)) {
	    	return "http://video.google.com/googleplayer.swf?docId=" + RegExp.$1;
	    } else if (src.match(/metacafe.com\/watch\/(\d+)/)){
	    	return "http://www.metacafe.com/fplayer/" + RegExp.$1 + ".swf";
	    } else if (src.match(/guba.com\/watch\/(\d+)/)){
	    	return "http://www.guba.com/f/root.swf?video_url=http://free.guba.com/uploaditem/" + RegExp.$1 + "/flash.flv&isEmbeddedPlayer=true";
	    } else if (src.match(/nicovideo.jp\/.*\?v=([^\&]+)/)){
	    	return "http://www.nicovideo.jp/thumb?v=" + RegExp.$1;
	    } else {
	    	return false;
	    }
	},
	onMouseOver: function(e) {
		var node = e.target;
		if (node.className != "outLink") return;
		var src = node.href;
		if (src.match(/\?url=/)) src = RegExp.rightContext;
		if (ImagePopup.isImage(src)) return;
		if (src.match(/2ch.net/)) return;
		var href = VideoPopup.getVideoSource(src);
		if (href) VideoPopup.show(node, href);
	},
	show: function(source, href) {
		if (!SkinPref.getBool("enableVideoPopup", true)) return;
		if (href.match(/\.jpg$/)) {
			ImagePopup.show(source, href, source.href);
			return;
		}
		if (href.indexOf("http://www.nicovideo.jp/") != -1) {
			VideoPopup.showNicoVideo(source, href);
			return;
		}
		var obj = document.createElement("object");
		obj.setAttribute("type", href.match(/\.divx$/) ? "video/divx" : "application/x-shockwave-flash");
		obj.setAttribute("data", href);
		obj.setAttribute("width",  "340");
		obj.setAttribute("height", "288");
		var param = document.createElement("param");
		param.setAttribute("name",  "wmode");
		param.setAttribute("value", "transparent");
		obj.appendChild(param);
		var nodePopup = Popup.add(obj, source);
		if (nodePopup) nodePopup.container.className = "popupVideo";
	},
	showNicoVideo: function(source, href) {
		var iframe = document.createElement("iframe");
		iframe.setAttribute("src", href);
		iframe.setAttribute("width",  "320");
		iframe.setAttribute("height", "216");
		iframe.setAttribute("frameborder", "0");
		iframe.setAttribute("scrolling", "no");
		iframe.setAttribute("onload", "VideoPopup.onNicoVideoLoad(event)");
		var nodePopup = Popup.add(iframe, source);
		if (nodePopup) nodePopup.container.className = "popupVideo";
	},
	onNicoVideoLoad: function(e){
		// G[łA[
		// e.currentTarget.style.height = e.currentTarget.contentDocument.body.clientHeight;
	}
};